<template>
  <v-dialog v-model="dialog" persistent max-width="50%">
    <v-card>
      <v-card-title>
        <span v-text="title" />
      </v-card-title>
      <v-card-text>
        <v-container>
          <v-row v-if="isEdit">
            <v-col cols="12">
              <v-text-field label="STO ID*" v-model="sto.id" required readonly />
            </v-col>
          </v-row>
          <v-row>
            <v-col cols="6">
              <v-select
                  :disabled="statusProgress"
                  v-model="sto.witel.regional.id"
                  :items="regionals"
                  item-text="nama"
                  item-value="id"
                  label="Pilih Regional"
                  @change="doChangeRegional"
              >
              </v-select>
            </v-col>
            <v-col cols="6">
              <v-select
                  :disabled="statusProgress"
                  v-model="sto.witel.id"
                  :items="witels"
                  item-text="nama"
                  item-value="id"
                  label="Pilih Witel"
              >
              </v-select>
            </v-col>
          </v-row>
          <v-row>
            <v-col cols="6">
              <v-text-field label="STO Alias*" v-model="sto.alias" :disabled="statusProgress" required />
            </v-col>
            <v-col cols="6">
              <v-text-field label="STO Nama*" v-model="sto.nama" :disabled="statusProgress" required />
            </v-col>
          </v-row>
        </v-container>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue darken-1" text @click="doSaveOrUpdate" :disabled="statusProgress">Simpan</v-btn>
        <v-btn color="blue darken-1" text @click="doReset" :disabled="statusProgress">Reset</v-btn>
        <v-btn color="blue darken-1" text @click="doClose" :disabled="statusProgress">Close</v-btn>
      </v-card-actions>
    </v-card>
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-dialog>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import stoService from '../service/StoService'
import witelService from '../service/WitelService'
import regionalService from '../service/RegionalService'

export default {
  name: "StoForm",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      regionals: [],
      witels: [],
      sto: {
        id: '0',
        alias: null,
        nama: null,
        witel: {
          id: null,
          regional: {
            id: null
          }
        }
      },
      title: null,
      dialog: false,
      isEdit: false,
      statusProgress: false,
    }
  },
  methods: {
    doChangeRegional() {
      let regional = this.sto.witel.regional.id
      this.retrieveWitel(regional)
    },
    doClose() {
      this.dialog = false
    },
    doAdd(title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.doReset()
      this.retrieveRegional()
    },
    doEdit(id, title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.retrieveSto(id)
    },
    doReset() {
      if (!this.isEdit)
        this.sto.id = '0'
      this.sto.alias = null
      this.sto.nama = null
      this.sto.witel.id = null
      this.sto.witel.regional.id = null
    },
    async doSaveOrUpdate() {
      if (!this.validation()) {
        return
      }
      let data = {
        id: this.sto.id,
        alias: this.sto.alias,
        nama: this.sto.nama,
        witel: {
          id: this.sto.witel.id,
          regional: {
            id: this.sto.witel.regional.id
          }
        }
      }
      this.statusProgress = true
      if (!this.isEdit) {
        await this.doSave(data)
      } else {
        await this.doUpdate(data.id, data)
      }
      this.statusProgress = false
    },
    doSave(data) {
      stoService.store(data)
          .then(async res => {
            if (res.data.status === "SUCCESS") {
              await this.$parent.doRefresh()
              this.doReset()
            }
            this.$refs.dlgMsg.doOpenMsg(res.data.message)
          })
          .catch(ex => {
            console.log(ex)
            this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
          })
    },
    doUpdate(id, data) {
      stoService.update(id, data)
          .then(async res => {
            if (res.data.status === "SUCCESS") {
              await this.$parent.doRefresh()
            }
            this.dialog = false
            this.$refs.dlgMsg.doOpenMsg(res.data.message)
          })
          .catch(ex => {
            console.log(ex)
            this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
          })
    },
    async retrieveRegional() {
      this.statusProgress = true
      await regionalService.getAll()
          .then(res => {
            let regionals = res.data.data
            for (let i in regionals) {
              let reg = {
                id: regionals[i].id,
                nama: regionals[i].id + " - " + regionals[i].nama,
              }
              this.regionals.push(reg)
            }
          })
      this.statusProgress = false
    },
    async retrieveWitel(regional) {
      this.statusProgress = true
      await witelService.getRegional(regional)
          .then(res => {
            this.witels = []
            let witels = res.data.data
            for (let i in witels) {
              let witel = {
                id: witels[i].id,
                nama: witels[i].id + " - " + witels[i].nama,
              }
              this.witels.push(witel)
            }
          })
      this.statusProgress = false
    },
    async retrieveSto(id) {
      this.statusProgress = true
      await stoService.getId(id)
          .then(async res => {
            this.sto = res.data.data
            await this.retrieveRegional()
            await this.retrieveWitel(this.sto.witel.regional.id)
          })
      this.statusProgress = false
    },
    validation() {
      if (this.sto.alias == null || this.sto.alias === '') {
        this.$refs.dlgMsg.doOpenMsg("Alias Harus Diisi")
        return false
      } else if (this.sto.nama == null || this.sto.nama === '') {
        this.$refs.dlgMsg.doOpenMsg("Nama Harus Diisi")
        return false
      } else if (this.sto.witel.id == null) {
        this.$refs.dlgMsg.doOpenMsg("Witel Harus Dipilih")
        return false
      } else if (this.sto.witel.regional.id == null) {
        this.$refs.dlgMsg.doOpenMsg("Regional Harus Dipilih")
        return false
      }
      return true
    }
  },
}
</script>

<style scoped>

</style>